using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Wizard;

public class Field76 : BackGroundBase
{
	public override int FieldId => 76;

	public Field76(string bgmId = "NONE")
		: base(bgmId)
	{
	}

	protected override void BattleFieldBuild()
	{
		BattleCoroutine.GetInstance().StartCoroutine(BackGroundBase.ObjectChecker(0.5f, _str3DFieldPath, delegate
		{
			base.Field = GameObject.Find(_str3DFieldPath);
			base.Field.transform.parent = GameMgr.GetIns().m_GameManagerObj.transform;
			_fieldModel = base.Field.transform.Find("md_bf_gate_01").gameObject;
			_fieldParticles = _fieldModel.transform.Find("Particles76").gameObject;
			AddParticleToFieldObjDictionary("gimic_1/Null_Adjust/ef_nemesis1_add_nor_1/ef_nemesis1_mlt_inv_1");
			AddParticleToFieldObjDictionary("gimic_1/Null_Adjust/ef_nemesis1_add_nor_1/ef_circle4_mlt_inv_1");
			AddParticleToFieldObjDictionary("gimic_1/Null_Adjust/ef_nemesis1_add_nor_1/ef_radial15_add_nor_1/ef_circle9_mlt_inv_1");
			AddParticleToFieldObjDictionary("gimic_1/Null_Adjust/ef_nemesis1_add_nor_1/ef_nemesis1_add_nor_1/ef_nemesis1_mlt_inv_1");
			AddParticleToFieldObjDictionary("shake/Null_Adjust/ef_circle4_mlt_inv_1");
			_fieldParticleSystemDictionary.Add("opening", _fieldParticles.transform.Find("opening").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("shake", _fieldParticles.transform.Find("shake").GetComponent<ParticleSystem>());
			_fieldParticleSystemDictionary.Add("gimic_1", _fieldParticles.transform.Find("gimic_1").GetComponent<ParticleSystem>());
			List<string> list = new List<string>(_fieldObjDictionary.Keys);
			List<GameObject> list2 = new List<GameObject>();
			for (int i = 0; i < _fieldObjDictionary.Count; i++)
			{
				list2.Add(_fieldObjDictionary[list[i]]);
			}
			GameMgr.GetIns().GetEffectMgr().SetUIParticleShader(list2, delegate
			{
				base.SetShaderGlobalColorBG = base.Field.transform.Find("SetMaterialColorBGManager").GetComponent<SetShaderGlobalColorBG>();
				base.IsLoadDone = true;
			}, isBattle: true, isField: true);
		}));
	}

	public override void StartFieldSetEffect(Vector3 pos)
	{
		GameMgr.GetIns().GetEffectMgr().Start(EffectMgr.EffectType.CMN_FIELD_SET_76, pos);
	}

	public override void StartFieldTapEffect(int areaId, Vector3 pos)
	{
		base.StartFieldTapEffect(areaId, pos);
		if (areaId == 1)
		{
			GameMgr.GetIns().GetEffectMgr().Start(EffectMgr.EffectType.CMN_FIELD_TAP_76_1, pos);
		}
	}

	protected override IEnumerator RunFieldOpening()
	{
		GameMgr.GetIns().GetSoundMgr().PlaySeByStr($"se_field_{_str3DFieldNo}_appear_1", "se_field_" + _str3DFieldNo, 0f, 0L);
		_fieldParticleSystemDictionary["opening"].Play();
		_battleCamera.Camera.transform.localPosition = new Vector3(0f, -20f, -1330f);
		_battleCamera.Camera.transform.localRotation = Quaternion.Euler(new Vector3(-3f, 0f, 0f));
		iTween.MoveTo(_battleCamera.Camera.gameObject, iTween.Hash("position", new Vector3(0f, 0f, -700f), "time", 1.7f, "delay", 0.3f, "islocal", true, "easetype", iTween.EaseType.easeInOutQuart));
		iTween.RotateTo(_battleCamera.Camera.gameObject, iTween.Hash("rotation", new Vector3(0f, 0f, 0f), "time", 1.7f, "delay", 0.3f, "islocal", true, "easetype", iTween.EaseType.easeInOutQuart));
		yield return new WaitForSeconds(2f);
		iTween.MoveTo(_battleCamera.Camera.gameObject, iTween.Hash("position", _battleCamera.BattleCameraPos, "time", 2f, "islocal", true, "easetype", iTween.EaseType.easeInOutExpo));
		iTween.RotateTo(_battleCamera.Camera.gameObject, iTween.Hash("rotation", _battleCamera.BattleCameraRot, "time", 2f, "islocal", true, "easetype", iTween.EaseType.easeInOutExpo));
		yield return new WaitForSeconds(0f);
	}

	protected override IEnumerator RunFieldGimic(GameObject obj)
	{
		string tag = obj.tag;
		if (tag != null && tag == "FieldGimic1" && _gimicCntDictionary[obj.tag] == 0)
		{
			GameMgr.GetIns().GetSoundMgr().PlaySeByStr($"se_field_{_str3DFieldNo}_gim_1", "se_field_" + _str3DFieldNo, 0f, 0L);
			_gimicCntDictionary[obj.tag]++;
			_fieldParticleSystemDictionary["gimic_1"].Play();
			yield return new WaitForSeconds(3f);
			_gimicCntDictionary[obj.tag] = 0;
		}
		yield return new WaitForSeconds(0f);
	}

	protected override IEnumerator RunFieldShake()
	{
		_fieldParticleSystemDictionary["shake"].Play();
		yield return new WaitForSeconds(0f);
	}
}
